package com.hfkj.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * mapper扩展类
 */
public interface BsUserSpreadRelMapperExt {

    @Select("<script>" +
            " select " +
            " b.header_img," +
            " b.user_name," +
            " b.phone," +
            " b.`status`," +
            " a.create_time" +
            " from bs_user_spread_rel a " +
            " LEFT JOIN bs_user b on b.id = a.user_id" +
            " where a.parent_user_id = #{param.parentUserId}" +
            " <if test='param.phone != null'> and b.phone like concat('%',#{param.phone},'%') </if>" +
            " ORDER BY a.create_time desc" +
            "</script>")
    List<HashMap<String,Object>> getTeamList(@Param("param") Map<String,Object> param);
    @Select("<script>" +
            " select " +
            " b.id userId," +
            " b.user_name userName," +
            " b.phone," +
            " b.create_time createTime," +
            " count(c.id) spreadCount" +
            " from bs_user_spread_power a" +
            " LEFT JOIN bs_user b on b.id = a.user_id" +
            " LEFT JOIN bs_user_spread_rel c on c.parent_user_id = b.id" +
            " where 1 = 1" +
            " <if test='param.phone != null'> and b.phone like concat('%',#{param.phone},'%') </if>" +
            " GROUP BY b.id" +
            " ORDER BY b.create_time desc" +
            "</script>")
    List<HashMap<String,Object>> getUserSpreadList(@Param("param") Map<String,Object> param);
}
